{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D, a project to enable 3D game development 
-- in Haskell. For the latest info, see http://www.hgamer3d.org .
-- 

-- (c) 2011-2014 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassMenuBase.chs

-- abstrakte Klasse!

module HGamer3D.Bindings.CEGUI.ClassMenuBase where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

{# import HGamer3D.Bindings.CEGUI.Utils #}
{# import HGamer3D.Bindings.CEGUI.ClassPtr #}
{# import HGamer3D.Bindings.CEGUI.StructHG3DClass #}

#include "ClassMenuBase.h"
{- function getItemSpacing -}
{#fun cegui_mnbs_getItemSpacing as getItemSpacing 
{ withHG3DClass* `HG3DClass' ,
 alloca- `Float' peekFloatConv*} -> `()'  #}

{- function isMultiplePopupsAllowed -}
{#fun cegui_mnbs_isMultiplePopupsAllowed as isMultiplePopupsAllowed 
{ withHG3DClass* `HG3DClass' ,
 alloca- `Bool' peekBoolUtil*} -> `()'  #}

{- function getAutoCloseNestedPopups -}
{#fun cegui_mnbs_getAutoCloseNestedPopups as getAutoCloseNestedPopups 
{ withHG3DClass* `HG3DClass' ,
 alloca- `Bool' peekBoolUtil*} -> `()'  #}

{- function getPopupMenuItem -}
{#fun cegui_mnbs_getPopupMenuItem as getPopupMenuItem 
{ withHG3DClass* `HG3DClass' ,
 alloca- `HG3DClass' peek*} -> `()'  #}

{- function setItemSpacing -}
{#fun cegui_mnbs_setItemSpacing as setItemSpacing 
{ withHG3DClass* `HG3DClass' ,
 realToFrac `Float' } -> `()'  #}

{- function changePopupMenuItem -}
{#fun cegui_mnbs_changePopupMenuItem as changePopupMenuItem 
{ withHG3DClass* `HG3DClass' ,
 withHG3DClass* `HG3DClass' } -> `()'  #}

{- function setAllowMultiplePopups -}
{#fun cegui_mnbs_setAllowMultiplePopups as setAllowMultiplePopups 
{ withHG3DClass* `HG3DClass' ,
 fromBool `Bool' } -> `()'  #}

{- function setAutoCloseNestedPopups -}
{#fun cegui_mnbs_setAutoCloseNestedPopups as setAutoCloseNestedPopups 
{ withHG3DClass* `HG3DClass' ,
 fromBool `Bool' } -> `()'  #}

{- function setPopupMenuItemClosing -}
{#fun cegui_mnbs_setPopupMenuItemClosing as setPopupMenuItemClosing 
{ withHG3DClass* `HG3DClass' } -> `()'  #}

